#!/usr/bin/env python3
# -*- coding:utf-8 -*-

import webiopi
import serial
import minimalmodbus
import json
import sys
import time
import datetime
import os
import subprocess
import re

import sqlite3
from array import array

from time import strftime
from subprocess import call




#=========================== SLAVE == ИНИЦИАЛИЗАЦИЯ С АДРЕСОМ 1========

instrumentA = minimalmodbus.Instrument('/dev/ttyAMA0', 3) 	# slave address (in decimal) 
instrumentA.mode = minimalmodbus.MODE_RTU   				# rtu or ascii mode        
instrumentA.serial.baudrate = 9600  						# baud
instrumentA.serial.bytesize = 8
instrumentA.serial.parity   = serial.PARITY_NONE
instrumentA.serial.stopbits = 1
instrumentA.serial.timeout  = 0.05  							# seconds
c0=0														# variables
c1=0
c2=0
c3=0
c4=0
c5=0
c6=0
c7=0
c8=0
c9=0
c10=0
c11=0
c12=0
c13=0
c14=0
c15=0
c16=0
c17=0
c18=0

counter_x = 0
counter_y = 0
counter_w = 0
over_current = 0


now = datetime.datetime.now()
cikl_write	= now.minute

# Чтение параметров электросчетчика и цикла записи
f = open('/home/pi/myproject/html/config/config.txt')
line = f.readlines()
time_write_base = line[139]
time_write_base = float(time_write_base)
counter_x = line[140]
counter_x = float(counter_x)
counter_y = line[141]
counter_y = float(counter_y)
counter_w = line[142]
counter_w = float(counter_w)
over_current = line[143]
over_current = float(over_current)
f.close()

GPIO = webiopi.GPIO
	
GPIO.setFunction(8, GPIO.OUT)			# реле №6
GPIO.setFunction(25, GPIO.OUT)			# реле №7
GPIO.setFunction(24, GPIO.OUT)			# реле №8


def setup():
    global adr_counter
    getRs485()
    adr_counter = z1	
    adr_counter = int(adr_counter)
	


#===========================SCRIPT & MACROS==================================================

#############################################################################################	
################## ЗАПИСЬ ДАННЫХ С ЭЛЕКТРОСЧЕТЧИКА ######################################
#############################################################################################

def loop():	

    global kwh,kwh_dynamic,cikl_write,time_write_base,counter_x,counter_y,counter_w,over_current,c0,c1,c2,c3,c4,c5,c6,c7,c8,c9,c10,c11,c12,c13
    try:
        c0 = instrumentA.read_float(0,4,2) 					# VOLTAGE, V 
        c1 = instrumentA.read_float(6,4,2) 					# CURRENT, A
        c2 = instrumentA.read_float(12,4,2) 				# POWER, W
        c3 = instrumentA.read_float(18,4,2) 				# ACTIVE_APPARENT_POWER, VA
        c4 = instrumentA.read_float(24,4,2) 				# REACTIVE_APPARENT_POWER, VAR
        c5 = instrumentA.read_float(30,4,2) 				# POWER_FACTOR
        c6 = instrumentA.read_float(36,4,2) 				# DEGREE
        c7 = instrumentA.read_float(70,4,2) 				# FREQUENCY, HZ
        c8 = instrumentA.read_float(72,4,2) 				# IMPORT_ACTIVE_ENERGY, Wh
        c9 = instrumentA.read_float(74,4,2) 				# EXPORT_ACTIVE_ENERGY, Wh
        c10 = instrumentA.read_float(86,4,2) 				# MAXIMUM_SYSTEM_POWER_DEMAND
        c11 = instrumentA.read_float(264,4,2)				# MAXIMUM_CURRENT_DEMAND, As	
		
        c12 = instrumentA.read_float(342,4,2) 				# TOTAL_ACTIVE_ENERGY, kwh				
        c12 = c12+(c12*counter_w)+(counter_x-counter_y)		# разница показаний с учетом потребления дополнительного счетчика и погрешности		
        c13 = instrumentA.read_float(344,4,2) 				# TOTAL_REACTIVE_ENERGY, kvarh		
		
        c0 = round(c0,2)
        c1 = round(c1,3)
        c2 = round(c2,2)
        c3 = round(c3,2)
        c4 = round(c4,2)
        c5 = round(c5,2)
        c6 = round(c6,2)
        c7 = round(c7,2)
        c8 = round(c8,2)
        c9 = round(c9,2)
        c10 = round(c10,2)	
        c11 = round(c11,2)	
        c12 = round(c12,2)	
        c13 = round(c13,2)	
        kwh = c12  
	

        # TEST	
        #c0 = instrumentA.read_register(0,3) 				# VOLTAGE, V 
        #c1 = instrumentA.read_register(1,3) 				# CURRENT, A	
        #c2 = instrumentA.read_register(2,3) 				# POWER, W
        #c3 = instrumentA.read_register(3,3) 				# ACTIVE_APPARENT_POWER, 
        #c4 = instrumentA.read_register(4,3) 				# REACTIVE_APPARENT_POWER, VAR		
        #c5 = instrumentA.read_register(6,3) 				# POWER_FACTOR	
        #c6 = instrumentA.read_register(7,3) 				# DEGREE				
        #c7 = instrumentA.read_register(8,3) 				# FREQUENCY, HZ	
        #c8 = instrumentA.read_register(9,3) 				# IMPORT_ACTIVE_ENERGY, Wh
        #c9 = instrumentA.read_register(10,3) 				# EXPORT_ACTIVE_ENERGY, Wh
        #c10 = instrumentA.read_register(11,3) 				# MAXIMUM_SYSTEM_POWER_DEMAND	
        #c11 = instrumentA.read_register(12,3) 				# MAXIMUM_CURRENT_DEMAND	
        #c12 = instrumentA.read_register(13,3) 
        #c12 = c12+(c12*counter_w)+(counter_x-counter_y)	# разница показаний с учетом потребления дополнительного счетчика и погрешности	
        #kwh = c12  		
        #c13 = instrumentA.read_register(14,3) 				# TOTAL_REACTIVE_ENERGY, kvarh	
		


					
		#SDM 230 registers
		#define SDM230_VOLTAGE                      0x0000                              //V
		#define SDM230_CURRENT                      0x0006                              //A
		#define SDM230_POWER                        0x000C                              //W
		#define SDM230_ACTIVE_APPARENT_POWER        0x0012                              //VA
		#define SDM230_REACTIVE_APPARENT_POWER      0x0018                              //VAR
		#define SDM230_POWER_FACTOR                 0x001E                              //
		#define SDM230_PHASE_ANGLE                  0x0024                              //DEGREE
		#define SDM230_FREQUENCY                    0x0046                              //Hz
		#define SDM230_IMPORT_ACTIVE_ENERGY         0x0048                              //Wh
		#define SDM230_EXPORT_ACTIVE_ENERGY         0x004A                              //Wh
		#define SDM230_IMPORT_REACTIVE_ENERGY       0x004C                              //VARh
		#define SDM230_EXPORT_REACTIVE_ENERGY       0x004E                              //VARh

		#define SDM230_TOTAL_SYSTEM_POWER_DEMAND    0x0054                              //W
		#define SDM230_MAXIMUM_SYSTEM_POWER_DEMAND  0x0056                              //W
		#define SDM230_CURRENT_POSITIVE_POWER_DEMAND 0x0058                             //W
		#define SDM230_MAXIMUM_POSITIVE_POWER_DEMAND 0x005A                             //W
		#define SDM230_CURRENT_REVERSE_POWER_DEMAND 0x005C                              //W
		#define SDM230_MAXIMUM_REVERSE_POWER_DEMAND 0x005E                              //W
		#define SDM230_CURRENT_DEMAND               0x0102                              //Amps
		#define SDM230_MAXIMUM_CURRENT_DEMAND       0x0108                              //Amps

		#define SDM230_TOTAL_ACTIVE_ENERGY          0x0156                              //kwh
		#define SDM230_TOTAL_REACTIVE_ENERGY        0x0158                              //kvarh

		#define SDM230_CURRENT_RESETTABLE_TOTAL_ACTIVE_ENERGY   0x0180                  //Wh
		#define SDM230_CURRENT_RESETTABLE_TOTAL_REACTIVE_ENERGY 0x0182                  //VARh



		
		# контроль перегрузки по току
        if (c1 > over_current):		
            GPIO.digitalWrite(24, GPIO.LOW)		
        else:		
            GPIO.digitalWrite(24, GPIO.HIGH)			
		
		
	
        #c12 = c12+(a12*counter_w)+(counter_x-counter_y)	# разница показаний с учетом потребления дополнительного счетчика и погрешности
   


        now = datetime.datetime.now()
        if (now.minute == cikl_write):		

			# расчет динамики потребления электроэнергии
            con = sqlite3.connect('/home/pi/data_whp.db')    	
            with con:
                cur = con.cursor()    
                cur.execute("SELECT * FROM counter_kwh")		
                while True:
                    row = cur.fetchone()
                    if row != None:
                        kwh_dynamic = list(row)
                        kwh_dynamic = kwh_dynamic[1:2]					
                        kwh_dynamic = str(kwh_dynamic)[1:-1]	
                        kwh_dynamic = float(kwh_dynamic)						
                        kwh_dynamic = (c12-kwh_dynamic)
		
                    else:
                        break		

						
            date = int(round(time.time() * 1000))
			
            conn = sqlite3.connect('/home/pi/data_whp.db') 
            cur = conn.cursor() 
            cur.execute("INSERT INTO counter_kwh VALUES(?, ?)", (date, kwh))			  
            conn.commit()			
            conn.close()
		
            #date = int(round(time.time() * 1000))	
            conn = sqlite3.connect('/home/pi/data_whp.db') 
            cur = conn.cursor() 
            cur.execute("INSERT INTO counter_kwh_dynamic VALUES(?, ?)", (date, kwh_dynamic))			  
            conn.commit()			
            conn.close()	


            cikl_write = cikl_write + time_write_base	
            if (cikl_write >= 60):
                cikl_write = cikl_write - 60	
	
    except Exception as e:
        pass			
		
	
    time.sleep(3)
	
#############################################################################################	
################## ЗАПРОС ДАННЫХ С WEB СТРАНИЦЫ #############################################
#############################################################################################	

@webiopi.macro
def getCounter():
    #instrumentA = minimalmodbus.Instrument('/dev/ttyAMA0', adr_counter)
    global c0, c1, c2, c3, c4, c5, c6, c7, c8, c9, c10, c11, c12, c13
    try:
        lista = c0,c1,c2,c3,c4,c5,c6,c7,c8,c9,c10,c11,c12,c13
        print("lista",lista)
        return json.dumps(lista)		
				
    except Exception as e:
        pass
	
		



#=============== ЧТЕНИЕ ДАННЫХ kWh	
@webiopi.macro	
def read_counter_kwh():
    global lista
    con = sqlite3.connect('/home/pi/data_whp.db')    	
    with con:
        cur = con.cursor()    
        cur.execute("SELECT * FROM counter_kwh")
        lista = cur.fetchall()				
        print (lista)				
        return json.dumps(lista)		
			
#=============== ОЧИСТКА ДАННЫХ kWh
@webiopi.macro	
def clear_counter_kwh():
    con = sqlite3.connect('/home/pi/data_whp.db') 
    cur = con.cursor()    
    delete = "DELETE FROM counter_kwh"
    cur.execute(delete)
    con.commit()

#=============================


@webiopi.macro	
def read_counter_kwh_dynamic():
    global lista
    con = sqlite3.connect('/home/pi/data_whp.db')    	
    with con:
        cur = con.cursor()    
        cur.execute("SELECT * FROM counter_kwh_dynamic")
        lista = cur.fetchall()				
        print (lista)				
        return json.dumps(lista)		
			
#=============== ОЧИСТКА ДАННЫХ
@webiopi.macro	
def clear_counter_kwh_dynamic():
    con = sqlite3.connect('/home/pi/data_whp.db') 
    cur = con.cursor()    
    delete = "DELETE FROM counter_kwh_dynamic"
    cur.execute(delete)
    con.commit()

#=============================




# Адреса контроллеров = чтение
	
@webiopi.macro
def getRs485():
    f = open('/home/pi/myproject/html/config/config_rs485.txt', 'r')
    global z0,z1,z2,z3,z4,z5
	
    z0 = f.readline()	
    z1 = f.readline()	
    z2 = f.readline()
    z3 = f.readline()
    z4 = f.readline()	
    z5 = f.readline()		
	
    f.close()
    lista = z0,z1,z2,z3,z4,z5
    print("lista",lista)	
    return json.dumps (lista)	
	
	
#=============================

# Адреса контроллеров = запись

@webiopi.macro	
def getRs485_save(adr_meteo,adr_counter,adr_radio,adr_relay_1,adr_relay_2,adr_reserve_2):	
    f = open('/home/pi/myproject/html/config/config_rs485.txt', 'w')
    f.write((adr_meteo) + "\n")
    f.write((adr_counter) + "\n")	
    f.write((adr_radio) + "\n")	
    f.write((adr_relay_1) + "\n")
    f.write((adr_relay_2) + "\n")	
    f.write((adr_reserve_2) + "\n")		
    f.close()	


	
	
	
#@webiopi.macro		
#def getRead_kwh():
	
    #date = int(round(time.time() * 1000))			
    #conn = sqlite3.connect('/home/pi/data_whp.db') 
    #cur = conn.cursor() 
    #cur.execute("SELECT * FROM r WHERE cpu_temp >= '1535733983898'")	


    #test = cur.fetchall()				
    #print (test)				
    #return test


    #conn.commit()			
    #conn.close()
		
	

    #f = open('/home/pi/myproject/html/config/log_kwh.txt', 'r')	
    #data = f.read()	
    #data = data.split('\n')	
    #f.close()
	
    #print (data)
    #return data	
 
 
    #month = '08' # input('месяц для поиска данных ->: ')
    #list_day = list(filter(lambda x: x.split('-')[1] == month,data))# выбираем дни нужного месяца
    #max_day = max(list_day, key = lambda x: x.split('-')[0]).split('-')[0] # находим последний день
    #list_max_day = list(filter(lambda x : x.split('-')[0] == max_day,list_day)) # фильтруем по последнему дню
    #list_day = sorted(list_max_day,key = lambda x : x.split(',')[0].split()[1].replace(':','')) # сортируем по времени
    #print(list_day[-1])# выводим последний с макс. временем
    #return list_day[-1]	
	
	

	